#ifndef M_DB_H
#define M_DB_H

/**
 * Copyright (C) 2001-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * database layer for mcdp
 *
 * extern void db_xxx(void);
 * - cd->db will be set to a new value, if dbase was found
 * 
 * extern void db_free(void);
 * - free current names / artist values
 */

#include "mcdp.h"

/* free all entries of cd->t[] */
extern void db_free(void);

/* workmandb file -> cd->t[] */
extern void db_wmdb(void);

/* cdrom with cdtext -> cd->t[] */
extern void db_cdtext(void);

/* local cddb file -> cd->t[] */
extern int db_cddb(void);

/* cd->t[] -> a new cddb file */
extern void db_cddb_write(void);

/**
 * communication with freedb servers
 * - see freedb.c ...
 */
extern void db_cddbp_read(void);
extern void db_cddbp_write(void);
extern void db_http_read(void);
extern void db_http_write(void);
extern void db_email_write(void);

#endif
