#ifndef ENV_H
#define ENV_H

/**
 * Copyright (C) 2001-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "params.h"
#include "stralloc.h"

extern char *env_get(char *s);
extern void env_init(void);

/* used environment variables */
extern char *mcdp_env_devcdrom;
extern char *mcdp_env_editor;
extern char *mcdp_env_mixer;
extern char *mcdp_env_lang;
extern char *mcdp_env_username;
extern char *mcdp_env_hostname;
extern char *mcdp_env_email;
extern char *mcdp_env_workmandb;
extern char *mcdp_env_cddb_path;
extern char *mcdp_env_cddb_server;
extern char *mcdp_env_cddb_webserver;
extern char *mcdp_env_cddb_submit;
extern char *mcdp_env_http_proxy;
extern char *mcdp_env_http_proxy_user;
extern char *mcdp_env_http_proxy_pass;

extern stralloc c_box;
extern stralloc c_normal;
extern stralloc c_status;
extern stralloc c_description;
extern stralloc c_headline;
extern stralloc c_cdname;
extern stralloc c_tracks;
extern stralloc c_ctrack;
extern stralloc c_note;
extern stralloc c_question;
extern stralloc c_cddb_send;
extern stralloc c_cddb_retr;
extern stralloc c_cddb_fail;

#endif
