#include "getkey.h"

/**
 * Copyright (C) 2001-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/**
 * getkey - read a key from non-blocking standard input
 *
 * @param keyset a set of possible keys, which are accepted
 * @return -1 on error, the number of the found key in keyset
 */
int getkey(char *keyset)
{
	char ch;
	unsigned int i;

	for (;;) {
		io_wantread(0); io_wait(); io_dontwantread(0);
		if (buffer_getc(buffer_0, &ch) != 1) continue;
		for (i=0; i<str_len(keyset); i++) {
			if (keyset[i] == ch) return i;
		}
	}

	return -1;
}
