#include "lang.h"
#include "env.h"
#include "case.h"

/**
 * Copyright (C) 2001-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

static char **lang_current;

/**
 * lang_msg - lookup some message in current language
 *
 * @param msg  this string should be looked up
 * @return     return the string in the currently selected language
 */
char *lang_msg(int msg)
{
	return lang_current[msg];
}

/**
 * lang_init - initialize the language settings
 *
 * @return nothing
 */
void lang_init(void)
{
	if (case_starts(mcdp_env_lang, "en")) {
		lang_current = lang_en; return;
	}

	if (case_starts(mcdp_env_lang, "de")) {
		lang_current = lang_de; return;
	}

	/* default language */
	lang_current = lang_en;

	return;
}
