#ifndef M_LANG_H
#define M_LANG_H

/**
 * Copyright (C) 2001-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* various translations */
extern char *lang_de[];
extern char *lang_en[];

extern void lang_init(void);
extern char *lang_msg(int msg);

enum lang_messages {
	MSG_HEADLINE_STATUS=0,
	MSG_HEADLINE_METHOD,
	MSG_HEADLINE_REPEAT,
	MSG_HEADLINE_DBINFO,
	MSG_HEADLINE_VOLUME,
	MSG_HEADLINE_TRACK,
	MSG_HEADLINE_PLAYLIST,
	MSG_HEADLINE_WHOLECD,
	MSG_HEADLINE_TRACKLIST,

	MSG_REPEAT_CDROM,
	MSG_REPEAT_TRACK,
	MSG_REPEAT_OFF,

	MSG_DRIVESTATUS_NODISC,
	MSG_DRIVESTATUS_OPEN,
	MSG_DRIVESTATUS_BUSY,
	MSG_DRIVESTATUS_OKAY,

	MSG_AUDIOSTATUS_PLAY,
	MSG_AUDIOSTATUS_PAUSE,
	MSG_AUDIOSTATUS_DONE,
	MSG_AUDIOSTATUS_ERROR,
	MSG_AUDIOSTATUS_NOSTATUS,

	MSG_EXTRASTATUS_OPENING,
	MSG_EXTRASTATUS_READING,
	MSG_EXTRASTATUS_CLOSING,

	MSG_METHOD_NORMAL,
	MSG_METHOD_PLAYLIST,
	MSG_METHOD_INTRO,
	MSG_METHOD_SHUFFLE,

	MSG_ERROR_DEV_LSTAT,
	MSG_ERROR_DEV_FILE,
	MSG_ERROR_DEV_OPEN,
	MSG_ERROR_TERMSIZE,

	MSG_DB_RESOLVING,
	MSG_DB_RESOLVING_FAILED,
	MSG_DB_CONNECTING,
	MSG_DB_CONNECTING_FAILED,
	MSG_DB_NOPOSTING,
	
	MSG_CONTINUE,
	MSG_CONTINUE_KEY,
	MSG_ABORT,
	MSG_ABORT_KEY,

	MSG_READ_QUESTION,
	MSG_READ_CDTEXT,
	MSG_READ_CDDB,
	MSG_READ_WMDB,
	MSG_READ_CDDBP,
	MSG_READ_HTTP,
	MSG_READ_KEYS,

	MSG_EDIT_QUESTION,
	MSG_EDIT_CDDB,
	MSG_EDIT_WMDB,
	MSG_EDIT_KEYS,

	MSG_SAVE_QUESTION,
	MSG_SAVE_CDDB,
	MSG_SAVE_CDDBP,
	MSG_SAVE_HTTP,
	MSG_SAVE_EMAIL,
	MSG_SAVE_KEYS,
	
	MSG_CATEGORY_QUESTION,
	MSG_CATEGORY01,
	MSG_CATEGORY02,
	MSG_CATEGORY03,
	MSG_CATEGORY04,
	MSG_CATEGORY05,
	MSG_CATEGORY06,
	MSG_CATEGORY07,
	MSG_CATEGORY08,
	MSG_CATEGORY09,
	MSG_CATEGORY10,
	MSG_CATEGORY11,
	MSG_CATEGORY_KEYS,

	MSG_SUBMITMODE_QUESTION,
	MSG_SUBMITMODE_TEST,
	MSG_SUBMITMODE_REAL,
	MSG_SUBMITMODE_KEYS
};

#endif
