#include "show.h"

/**
 * Copyright (C) 2001-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/**
 * for porting to other systems, we may create some #ifdef' here!
 */
#define T_NORM   "\033[0m"         /* for most terms: normal mode */
#define T_BOLD   "\033[1m"         /* for most terms: bold mode */
#define T_INIT   "\e[?25l\e(B\e)0" /* for init stuff, hide also mouse */
#define T_QUIT   "\e[?25h"         /* for quit stuff, unhide mouse */
#define T_CLEAR  "\033[2J\033[H"   /* for most terms: clear screen + goto 1:1 */

int *lines_right, *lines_left;

char *show_t_norm=T_NORM;
char *show_t_bold=T_BOLD;
char *show_t_init=T_INIT;
char *show_t_quit=T_QUIT;
char *show_t_clear=T_CLEAR;

int show_maxx=0;
int show_maxy=0;
int show_x1=0;

static void waitsometime(void)
{
	if (io_canwrite(1) == 1) return;

	io_wantwrite(1);
	io_wait();
	io_dontwantwrite(1);

	return;
}

void flush(void)
{
	waitsometime();
	while (buffer_flush(buffer_1) == -1) {
		io_eagain(1); flush();
	}

	return;
}

void show(char *s)
{
	while (buffer_puts(buffer_1, s) == -1) {
		io_eagain(1); show(s);
	}

	return;
}

void show_n(char *s, int n)
{
	while (buffer_put(buffer_1, s, n) == -1) {
		io_eagain(1); show_n(s,n);
	}

	return;
}

void show_sa(stralloc *sa)
{
	while (buffer_putsa(buffer_1, sa) == -1) {
		io_eagain(1); show_sa(sa);
	}

	return;
}
