#ifndef M_SHOW_H
#define M_SHOW_H

#include "mcdp.h"
#include "lang.h"

/**
 * Copyright (C) 2001-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

extern void show(char *s);
extern void show_n(char *s, int len);
extern void show_sa(stralloc *sa);
extern void flush(void);

/* is the maxima of the left descriptions! */
extern int show_maxx;
extern int show_maxy;
extern int show_x1;

/* various terminal standard strings */
extern char *show_t_clear;
extern char *show_t_norm;
extern char *show_t_bold;
extern char *show_t_init;
extern char *show_t_quit;

/* init / quit strings for terminal */
extern void show_terminit(void);
extern void show_termquit(void);

/* misc functions */
extern void show_init(void);
extern void show_gotoxy(int x, int y);
extern void show_hline(int i, char *ch);
extern void show_box(int x1, int y1, int x2, int y2);

/* functions for the main window handling */
#define show_main(l,r) show_main_colorS(0,l,0,r)
#define show_main_color(cl,l,cr,r) show_main_color_doit(0,cl,l,cr,r) /* permanent */
#define show_main_colorS(cl,l,cr,r) show_main_color_doit(1,cl,l,cr,r) /* scrolling */
extern void show_main_color_doit(int type, int cleft, stralloc *left, int cright, stralloc *right);
extern void show_main_clear(void);
extern void show_main_reset(void);
extern void show_main_scroll(int x);

/* update functions */
extern void show_time(void);
extern void show_dbase(void);
extern void show_status(void);
extern void show_method(void);
extern void show_repeat(void);
extern void show_volume(void);
extern void show_trackmod(void);
extern void show_device(void);
extern void show_tracks(void);

#endif
