#include "show.h"

/**
 * Copyright (C) 2001-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

void show_init(void)
{
	unsigned int x;

	tty_getsize(&show_maxx, &show_maxy);
	if (show_maxx < 65 || show_maxy < 20) {
		die_term(lang_msg(MSG_ERROR_TERMSIZE));
	}
	show_terminit(); /* clear screen and so... */
	show_main_reset();
	show_sa(&c_box);
	show(BX_IN);
	show_box(1, 1, show_maxx, show_maxy); /* the bigbox */

	/* top line */
	show_gotoxy(1,7);
	show(AC_ML); show_hline(show_maxx-1,AC_HL); show(AC_MR);

	/* bottom line */
	show_gotoxy(1,show_maxy-2);
	show(AC_ML); show_hline(show_maxx-1,AC_HL); show(AC_MR);

	/* vertical line */
	show_gotoxy(19, 7); show(AC_MB);
	for (show_x1=8; show_x1<show_maxy-2; show_x1++) {
		show_gotoxy(19, show_x1); show(AC_VL);
	}
	x = str_len(lang_msg(MSG_HEADLINE_VOLUME))+9;
	show_gotoxy(x, show_maxy); show(AC_MT);
	show_gotoxy(x, show_maxy-1); show(AC_VL);
	if (x == 19) {
		show_gotoxy(x, show_maxy-2); show(AC_MM);
	} else {
		show_gotoxy(19, show_maxy-2); show(AC_MT);
		show_gotoxy(x, show_maxy-2); show(AC_MB);
	}
	show(BX_OUT);

	/* show_x1 == max of these three descriptions */
	show_x1 = 0;
	show_x1 = max(show_x1, (int)str_len(lang_msg(MSG_HEADLINE_STATUS)));
	show_x1 = max(show_x1, (int)str_len(lang_msg(MSG_HEADLINE_METHOD)));
	show_x1 = max(show_x1, (int)str_len(lang_msg(MSG_HEADLINE_REPEAT)));
	show_x1 += 4;

	/* volume: and source: */
	show_sa(&c_description);
	show_gotoxy(3, show_maxy-1); show(lang_msg(MSG_HEADLINE_VOLUME));
	show_gotoxy(str_len(lang_msg(MSG_HEADLINE_VOLUME))+11, show_maxy-1);
	show(lang_msg(MSG_HEADLINE_DBINFO));

	show_gotoxy(3, 4); show(lang_msg(MSG_HEADLINE_STATUS)); /* status */
	show_gotoxy(3, 5); show(lang_msg(MSG_HEADLINE_METHOD)); /* method */
	show_gotoxy(3, 6); show(lang_msg(MSG_HEADLINE_REPEAT)); /* repeat */

	/* the max of the three descriptions in right upper corner */
	x = 0;
	x = max(x, str_len(lang_msg(MSG_HEADLINE_TRACK)));
	x = max(x, str_len(lang_msg(MSG_HEADLINE_PLAYLIST)));
	x = max(x, str_len(lang_msg(MSG_HEADLINE_WHOLECD)));
	x = show_maxx - x - (5+3+5+3+5+2);
	show_gotoxy(x, 4); show(lang_msg(MSG_HEADLINE_TRACK)); /* track */
	show_gotoxy(x, 5); show(lang_msg(MSG_HEADLINE_PLAYLIST)); /* playlist */
	show_gotoxy(x, 6); show(lang_msg(MSG_HEADLINE_WHOLECD)); /* full cdrom */

	show_sa(&c_headline);
	show_gotoxy(5,8);
	show(lang_msg(MSG_HEADLINE_TRACKLIST)); /* tracklist */

	return;
}
