#include "show.h"
#include "slash.h"

/**
 * Copyright (C) 2001-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

void show_method(void)
{
	static unsigned int last=0;
	stralloc sa;

	stralloc_init(&sa);
	show_sa(&c_status);
	show_gotoxy(show_x1, 5);

	switch (cd->method) {
	case M_PLAY_CD:
		if (!stralloc_cats(&sa, lang_msg(MSG_METHOD_NORMAL))) die_nomem();
		break;
	case M_PLAY_LIST:
		if (!stralloc_cats(&sa, lang_msg(MSG_METHOD_PLAYLIST))) die_nomem();
		break;
	case M_INTRO:
		if (!stralloc_cats(&sa, lang_msg(MSG_METHOD_INTRO))) die_nomem();
		if (!stralloc_cats(&sa, " (")) die_nomem();
		if (!stralloc_cat_uint(&sa, cd->intro)) die_nomem();
		if (!stralloc_cats(&sa, ")")) die_nomem();
		break;
	}

	if (cd->flags & F_M_SHUFFLE) {
		if (!stralloc_cats(&sa, slash)) die_nomem();
		if (!stralloc_cats(&sa, lang_msg(MSG_METHOD_SHUFFLE))) die_nomem();
	}

	show_sa(&sa);
	while (sa.len < last) { show(" "); last--; }
	last=sa.len;

	stralloc_free(&sa);

	return;
}
