#include "mcdp.h"
#include "sig.h"
#include "die.h"

/**
 * Copyright (C) 2001-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

void sig_handler(int sig)
{
	stralloc sa;

	/* screen size has changed */
	if (sig == SIGWINCH) {
		set(cd->updates, U_ALL);
		return;
	}

	/* we just exit @ CTRL-C */
	if (sig == SIGINT) {
		mcdp_quit(0);
	}

	/* exit with a small 'killed by sig X' message */
	tty_restore();
	show_termquit();
	
	stralloc_init(&sa);
	if (!stralloc_copys(&sa, "killed by signal: ")) die_nomem();
	if (!stralloc_cat_uint(&sa, (unsigned int)sig)) die_nomem();
	if (!stralloc_cats(&sa, "\n")) die_nomem();
	while (buffer_putsaflush(buffer_2, &sa) == -1);
	stralloc_free(&sa);

	_exit(sig);
}
