#include "sig.h"

/**
 * Copyright (C) 2001-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

void sig_set(int signum, sig_function *func)
{
	struct sigaction sa;

	sa.sa_handler=func;
	(void)sigemptyset(&sa.sa_mask);
	(void)sigaddset(&sa.sa_mask,signum);
#ifdef SA_RESTART
	sa.sa_flags=SA_RESTART;
#endif
	(void)sigaction(signum, &sa, 0);

	return;
}
