#include "tty.h"

/**
 * Copyright (C) 2001-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _POSIX_VDISABLE
#define _POSIX_VDISABLE '\0'
#endif

struct termios told;
int tty_init_done=0;

void tty_init(void)
{
	struct termios tnew;
	tty_init_done=1;

	if (tcgetattr(0, &told) == -1) {
		die_term("tcgetattr()");
	}

	tnew = told;

	tnew.c_lflag &= ~(ICANON|ECHO|ECHOE);
	tnew.c_cc[VMIN]=1;

	if (tcsetattr(0, TCSANOW, &tnew) == -1) {
		die_term("tcsetattr()");
	}

	return;
}
